package provide turtle 0.1

# Ʋ ׷ 
proc tStart {} {
	global turtle
	global turtle_arrow_id

	set turtle(degree) 0
	set turtle(PI) [expr 2 * asin(1.0)]
	set turtle(x_position) 100
	set turtle(y_position) 100
	set turtle(draw) 1
	set turtle(delay) 0
	set turtle(width) 1
	set turtle(color) black
	set turtle(canvas_color) white

	canvas .turtle_canvas -bg $turtle(canvas_color)
	pack .turtle_canvas -expand true -fill both

	set turtle_arrow_id [.turtle_canvas create line $turtle(x_position) $turtle(y_position) \
		[expr $turtle(x_position) - 1] $turtle(y_position) \
		-arrow first -width $turtle(width) -fill $turtle(color)]
}

# 
proc tforward n {
	global turtle turtle_arrow_id

	set radian [expr $turtle(degree) * ($turtle(PI) / 180)]
	
	for {set count 0} {$count < $n} {incr count} {
		set turtle_x_forward [expr cos($radian)]
		set turtle_y_forward [expr sin($radian)]
		if {$turtle(draw) == 1} {
			.turtle_canvas create line $turtle(x_position) $turtle(y_position) \
				[expr $turtle_x_forward + $turtle(x_position)] [expr $turtle_y_forward + $turtle(y_position)] \
				-width $turtle(width) -fill $turtle(color)
		}
		set turtle(x_position) [expr $turtle_x_forward + $turtle(x_position)]
		set turtle(y_position) [expr $turtle_y_forward + $turtle(y_position)]

		.turtle_canvas move $turtle_arrow_id $turtle_x_forward $turtle_y_forward

		update

		tdelay
	}
}

# 
proc tbackward n {
	global turtle

	tright 180

	tforward $n
}

# ݽð   ̵
proc tleft n {
	global turtle
	set turtle(degree) [expr $turtle(degree) - $n]

	if {$turtle(degree) < 0} {
		set turtle(degree) [expr $turtle(degree) + 360]
	}

	tarrow_draw

	tdelay
}

# ð   ̵
proc tright n {
	global turtle
	set turtle(degree) [expr $n + $turtle(degree)]

	if {$turtle(degree) > 360} {
		set turtle(degree) [expr $turtle(degree) - 360]
	}

	tarrow_draw

	tdelay
}

# ź̸ ׸...   ǥ
proc tarrow_draw {} {
	global turtle turtle_arrow_id

	.turtle_canvas delete $turtle_arrow_id

	set radian [expr ($turtle(degree) + 180) * ($turtle(PI) / 180)]
	set arrow_x [expr cos($radian)]
	set arrow_y [expr sin($radian)]

	set turtle_arrow_id [.turtle_canvas create line $turtle(x_position) $turtle(y_position) \
		[expr $arrow_x + $turtle(x_position)] [expr $arrow_y + $turtle(y_position)] \
		-arrow first -width $turtle(width) -fill $turtle(color)]

	update
}

# ̵  ׸ ʰ 
proc tup {} {
	global turtle
	set turtle(draw) 0
}

# ̵  ׸ default
proc tdown {} {
	global turtle
	set turtle(draw) 1
}

# ׸ ׸  ð  (ms)
proc tdelayset n {
	global turtle
	set turtle(delay) $n
}

# ð  Լ
proc tdelay {} {
	global turtle

	set start_time [clock clicks -milliseconds]

	while { [expr [clock clicks -milliseconds] - $start_time] < $turtle(delay)} {
	}
}

# ź  ġ 
proc tsetxy {x y} {
	global turtle turtle_arrow_id

	set move_x [expr $x - $turtle(x_position)]
	set move_y [expr $y - $turtle(y_position)]

	.turtle_canvas move $turtle_arrow_id $move_x $move_y

	set turtle(x_position) $x
	set turtle(y_position) $y
}

# ź̸ ó ġ
proc thome {} {
	tsetxy 100 100
}

# ȭ  - ź ġ ̵ 
proc tclear {} {
	global turtle_arrow_id

	foreach item [.turtle_canvas find all] {
		if {$item != $turtle_arrow_id} {
			.turtle_canvas delete $item
		}
	}
}

# ȭ  - ʱȭ
proc tclearscreen {} {
	global turtle turtle_arrow_id

	set turtle(x_position) 100
	set turtle(y_position) 100
	set turtle(degree) 0
	set turtle(width) 1
	set turtle(color) black
	set turtle(canvas_color) white

	tclear

	tsetbgcolor $turtle(canvas_color)

	.turtle_canvas delete $turtle_arrow_id

	set turtle_arrow_id [.turtle_canvas create line $turtle(x_position) $turtle(y_position) \
		[expr $turtle(x_position) - 1] $turtle(y_position) \
		-arrow first -fill $turtle(color) -width $turtle(width)]
}

# ź ũ 
proc tsetsize n {
	global turtle

	set turtle(width) $n

	tarrow_draw
}

# ź  
proc tsetcolor {args} {
	global turtle

	set temp $turtle(color)

	if {$args == ""} {
		set turtle(color) [tk_chooseColor]
	} else {
		set turtle(color) $args
	}

	if {$turtle(color) == ""} {
		set turtle(color) $temp
	}

	tarrow_draw
}

# ĵ  
proc tsetbgcolor {args} {
	global turtle

	set temp $turtle(canvas_color)

	if {$args == ""} {
		set turtle(canvas_color) [tk_chooseColor]
	} else {
		set turtle(canvas_color) $args
	}

	if {$turtle(canvas_color) == ""} {
		set turtle(canvas_color) $temp
	} else {
		.turtle_canvas config -bg $turtle(canvas_color)
	}
}

# Ʋ ׷ ü  
proc tinfo {} {
	global turtle tcl_platform

	if {"$tcl_platform(platform)" != "unix"} {
		console show
	}

	set canvas_width [.turtle_canvas cget -width]
	set canvas_height [.turtle_canvas cget -height]

	puts "turtle X position: $turtle(x_position)"
	puts "turtle Y position: $turtle(y_position)"
	puts "turtle degree: $turtle(degree) degree"
	puts "turtle width: $turtle(width) pixel"
	puts "turtle color: $turtle(color)"
	puts "turtle canvas color: $turtle(canvas_color)"
	puts "turtle canvas width: $canvas_width"
	puts "turtle canvas height: $canvas_height"
	puts "turtle draw: $turtle(draw)"
	puts "turtle delay: $turtle(delay) ms"
}